package
{
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	import org.flixel.*;
	
	public class Halo extends FlxSprite
	{
		
		private function drawCircle(target:BitmapData, cX:Number, cY:Number, r:Number, color24:uint, alpha:Number):void
		{
			var circle:Sprite = new Sprite;
			circle.graphics.beginFill(color24,alpha);
			circle.graphics.drawCircle(cX, cY, r);
			circle.graphics.endFill();	
			target.draw(circle, new Matrix());
		}
		
		private var r:Number;
		public var target:Charger;
		
		public override function update():void
		{
			this.x=target.x-r+target.width/2;
			this.y=target.y-r+target.height/2;
			super.update();
		}

		private var _p:Point;
		private var _r:Rectangle;
		
		public function Halo(R:Number, Target:Charger)
		{
			_p = new Point(0, 0);
			_r = new Rectangle(0,0,2*R,2*R); // I don't know why I need this.

			super(Target.x, Target.y);
			r=R;
			this.width=2*r;
			this.height=2*r;
			target=Target;
//			this.createGraphic(2*r,2*r,0xffffffff,false,"halo");
//			this._pixels.fillRect(this._pixels.rect,0x00000000);
//			drawCircle(this._pixels,r,r,r,0xffffff00,0.1);
//			this.resetHelpers();
		}
		
		
		override public function render():void
		{			
//			super.render();
			var cx:int = int(target.x)+int(FlxG.scroll.x)+target.beaconx;
			var cy:int = int(target.y)+(FlxG.scroll.y)+target.beacony;

			var spr:Robot = target as Robot;
			if (spr!=null)
			{				
				var drawShape:Shape = new Shape();	
				drawShape.graphics.moveTo(cx,cy);		
				if (spr.charging)
				{			
					drawShape.graphics.lineStyle(1, 0xffbb00);	
					drawShape.graphics.lineTo(int(FlxG.scroll.x)+spr.chargetox,int(FlxG.scroll.y)+spr.chargetoy);					
				}
				else if (spr.controlled)
				{
					drawShape.graphics.lineStyle(1, 0x886600);						
					drawShape.graphics.lineTo(cx+r*Math.cos(spr.theta),cy+r*Math.sin(spr.theta));
				}
				FlxG.buffer.draw(drawShape);
			}
			
			if (target.charging)
			{
				var circle:Shape = new Shape();
			
				circle.graphics.beginFill(0xffff00,0.1);
				circle.graphics.drawCircle(cx,cy, r);
				circle.graphics.endFill();				
			
				FlxG.buffer.draw(circle);
			}
		}
	}
}